{-# OPTIONS -XRank2Types #-}

module Monatron.MonadT (
  MonadT(..), tmap,
  module Control.Monad
) where

import Control.Monad

----------------------------------------------------------
-- Monad transformer class
----------------------------------------------------------

class MonadT t where
    lift    :: Monad m  => m a -> t m a
    treturn :: Monad m => a -> t m a
    treturn =  lift. return
    tbind   :: Monad m => t m a -> (a -> t m b) -> t m b
    tmixmap :: (Monad m, Monad n ) => 
               (forall a.   m a ->   n a) -> 
               (forall b.   n b ->   m b) -> 
                          t m c -> t n c

tmap   :: (Monad m, MonadT t)  => (forall x. m x -> m x) -> t m a -> t m a
tmap m = tmixmap m m
